/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.lokalisierung.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="LOKALISIERUNG.UK",
     query="SELECT o FROM Lokalisierung o WHERE "

                         + "o"
                +".locale"
              +" = ?1"

             +" AND "         + "o"
                +".schluessel"
              +" = ?2"

     ,
   hints = {
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="LOKALISIERUNG.All",
     query="SELECT o FROM Lokalisierung o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="LOKALISIERUNG.Schluessel",
     query="SELECT OBJECT(o) FROM Lokalisierung o WHERE o.schluessel=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "LOKALISIERUNG")
// @javax.persistence.IdClass(LokalisierungPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    
public
 class Lokalisierung
extends AbstractLokalisierung
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Lokalisierung() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Lokalisierung(Lokalisierung original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "lokalisierung_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Lokalisierung")
    @javax.persistence.TableGenerator(name = "Lokalisierung", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Lokalisierung", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient LokalisierungPK pkCache;

  @Override
  public LokalisierungPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new LokalisierungPK(getId());
    }

    return pkCache;
  }

  public static <E extends Lokalisierung> java.util.Map<LokalisierungPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<LokalisierungPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Lokalisierung> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedLocale = false;
          hasChangedModul = false;
          hasChangedSchluessel = false;
          hasChangedWertGeaendert = false;
          hasChangedWertPropertydatei = false;
  



    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "LOCALE", nullable = LokalisierungConstants.LOCALE_NULLABLE)
    
  protected de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale locale =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLocale = false;

  public boolean hasChangedLocale(){
    return hasChangedLocale;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertLocale = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale wertNachLadenLocale;
  
  /**
   * 
   *
   * getter for LOKALISIERUNG.LOCALE
   */
    @Override   public  de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale getLocale() {
        return locale;
      }

  /**
   * 
   *
   * setter for LOKALISIERUNG.LOCALE
   *
   * @param locale
   */
  @Override   public void setLocale( de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale locale) {

       resetTkCache();
                  de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale localeInternal = locale;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.locale
      , localeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLocale |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("locale");
      }


             if (!isSeitLadenVeraendertLocale) {
          isSeitLadenVeraendertLocale = thisAttributChanged;
         if (isSeitLadenVeraendertLocale){
           wertNachLadenLocale=this.locale;
         }
       }
      

       this.locale = localeInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "MODUL", nullable = LokalisierungConstants.MODUL_NULLABLE)
    
  protected de.ivu.elect.business.lokalisierung.entity.LokalisierungModul modul =  null;

  @javax.persistence.Transient
  protected boolean hasChangedModul = false;

  public boolean hasChangedModul(){
    return hasChangedModul;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertModul = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.lokalisierung.entity.LokalisierungModul wertNachLadenModul;
  
  /**
   * 
   *
   * getter for LOKALISIERUNG.MODUL
   */
    @Override   public  de.ivu.elect.business.lokalisierung.entity.LokalisierungModul getModul() {
        return modul;
      }

  /**
   * 
   *
   * setter for LOKALISIERUNG.MODUL
   *
   * @param modul
   */
  @Override   public void setModul( de.ivu.elect.business.lokalisierung.entity.LokalisierungModul modul) {

       resetTkCache();
                  de.ivu.elect.business.lokalisierung.entity.LokalisierungModul modulInternal = modul;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.modul
      , modulInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedModul |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("modul");
      }


             if (!isSeitLadenVeraendertModul) {
          isSeitLadenVeraendertModul = thisAttributChanged;
         if (isSeitLadenVeraendertModul){
           wertNachLadenModul=this.modul;
         }
       }
      

       this.modul = modulInternal;

         }

        
      @javax.persistence.Column(name = "SCHLUESSEL", nullable = LokalisierungConstants.SCHLUESSEL_NULLABLE, length=LokalisierungConstants.SCHLUESSEL_MAX_LENGTH)
        
  protected java.lang.String schluessel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedSchluessel = false;

  public boolean hasChangedSchluessel(){
    return hasChangedSchluessel;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSchluessel = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenSchluessel;
  
  /**
   * 
   *
   * getter for LOKALISIERUNG.SCHLUESSEL
   */
    @Override   public  java.lang.String getSchluessel() {
        return schluessel;
      }

  /**
   * 
   *
   * setter for LOKALISIERUNG.SCHLUESSEL
   *
   * @param schluessel
   */
  @Override   public void setSchluessel( java.lang.String schluessel) {

       resetTkCache();
                  
                          java.lang.String schluesselInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(schluessel, LokalisierungConstants.SCHLUESSEL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.schluessel
      , schluesselInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSchluessel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("schluessel");
      }


             if (!isSeitLadenVeraendertSchluessel) {
          isSeitLadenVeraendertSchluessel = thisAttributChanged;
         if (isSeitLadenVeraendertSchluessel){
           wertNachLadenSchluessel=this.schluessel;
         }
       }
      

       this.schluessel = schluesselInternal;

         }

        
  @javax.persistence.Column(name = "WERT_GEAENDERT", nullable = LokalisierungConstants.WERT_GEAENDERT_NULLABLE, length=LokalisierungConstants.WERT_GEAENDERT_MAX_LENGTH)
        
  protected java.lang.String wertGeaendert =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWertGeaendert = false;

  public boolean hasChangedWertGeaendert(){
    return hasChangedWertGeaendert;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWertGeaendert = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWertGeaendert;
  
  /**
   * 
   *
   * getter for LOKALISIERUNG.WERT_GEAENDERT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getWertGeaendert() {
        return wertGeaendert;
      }

  /**
   * 
   *
   * setter for LOKALISIERUNG.WERT_GEAENDERT
   *
   * @param wertGeaendert
   */
  @Override   public void setWertGeaendert(@javax.annotation.Nullable  java.lang.String wertGeaendert) {

       resetTkCache();
                  
                          java.lang.String wertGeaendertInternal = de.ivu.elect.jee.entity.EntityUtil.trimToMaxLength(wertGeaendert, LokalisierungConstants.WERT_GEAENDERT_MAX_LENGTH, getId(), getClass());
                  
                java.lang.String alterWert = getWertGeaendert();
         wertGeaendertInternal = preProcessWertGeaendert(wertGeaendertInternal);
         preSetWertGeaendert(alterWert, wertGeaendertInternal);
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wertGeaendert
      , wertGeaendertInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWertGeaendert |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wertGeaendert");
      }


             if (!isSeitLadenVeraendertWertGeaendert) {
          isSeitLadenVeraendertWertGeaendert = thisAttributChanged;
         if (isSeitLadenVeraendertWertGeaendert){
           wertNachLadenWertGeaendert=this.wertGeaendert;
         }
       }
      

       this.wertGeaendert = wertGeaendertInternal;

                postSetWertGeaendert(alterWert, wertGeaendertInternal);
         }

  
    @Override
    protected java.lang.String preProcessWertGeaendert(java.lang.String neuerWert) {
      return super.preProcessWertGeaendert(neuerWert);
    }

    @Override
    protected void preSetWertGeaendert(java.lang.String alterWert, java.lang.String neuerWert) {
      super.preSetWertGeaendert(alterWert, neuerWert);
    }

    @Override
    protected void postSetWertGeaendert(java.lang.String alterWert, java.lang.String neuerWert) {
      super.postSetWertGeaendert(alterWert, neuerWert);
    }
        
  @javax.persistence.Column(name = "WERT_PROPERTYDATEI", nullable = LokalisierungConstants.WERT_PROPERTYDATEI_NULLABLE, length=LokalisierungConstants.WERT_PROPERTYDATEI_MAX_LENGTH)
        
  protected java.lang.String wertPropertydatei =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWertPropertydatei = false;

  public boolean hasChangedWertPropertydatei(){
    return hasChangedWertPropertydatei;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWertPropertydatei = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWertPropertydatei;
  
  /**
   * 
   *
   * getter for LOKALISIERUNG.WERT_PROPERTYDATEI
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getWertPropertydatei() {
        return wertPropertydatei;
      }

  /**
   * 
   *
   * setter for LOKALISIERUNG.WERT_PROPERTYDATEI
   *
   * @param wertPropertydatei
   */
  @Override   public void setWertPropertydatei(@javax.annotation.Nullable  java.lang.String wertPropertydatei) {

       resetTkCache();
                  
                          java.lang.String wertPropertydateiInternal = de.ivu.elect.jee.entity.EntityUtil.trimToMaxLength(wertPropertydatei, LokalisierungConstants.WERT_PROPERTYDATEI_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wertPropertydatei
      , wertPropertydateiInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWertPropertydatei |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wertPropertydatei");
      }


             if (!isSeitLadenVeraendertWertPropertydatei) {
          isSeitLadenVeraendertWertPropertydatei = thisAttributChanged;
         if (isSeitLadenVeraendertWertPropertydatei){
           wertNachLadenWertPropertydatei=this.wertPropertydatei;
         }
       }
      

       this.wertPropertydatei = wertPropertydateiInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Lokalisierung:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Lokalisierung other){
                             other.locale = this.locale;
                                other.modul = this.modul;
                                other.schluessel = this.schluessel;
                                other.wertGeaendert = this.wertGeaendert;
                                other.wertPropertydatei = this.wertPropertydatei;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Lokalisierung.class)){
        copyEntityAttributesUsingSetter((Lokalisierung) other.castTo(Lokalisierung.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Lokalisierung: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Lokalisierung other){
               other.setLocale(this.locale);
                  other.setModul(this.modul);
                  other.setSchluessel(this.schluessel);
                  other.setWertGeaendert(this.wertGeaendert);
                  other.setWertPropertydatei(this.wertPropertydatei);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Lokalisierung other){
                       if (hasChangedLocale) {
        other.setLocale(this.locale);
      }
                             if (hasChangedModul) {
        other.setModul(this.modul);
      }
                             if (hasChangedSchluessel) {
        other.setSchluessel(this.schluessel);
      }
                             if (hasChangedWertGeaendert) {
        other.setWertGeaendert(this.wertGeaendert);
      }
                             if (hasChangedWertPropertydatei) {
        other.setWertPropertydatei(this.wertPropertydatei);
      }
             }





    @javax.persistence.Transient
    private transient LokalisierungTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public LokalisierungTK getLokalisierungTK(){
    if (tkCache==null) {
    tkCache = new LokalisierungTK(

getLocale()
, getSchluessel()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getLokalisierungTK();
    }

  @Override
  public LokalisierungUK getUk(){
    return getLokalisierungUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Lokalisierung.class;
  }

public LokalisierungUK getLokalisierungUK(){

   return  new LokalisierungUK(

getLocale()
, getSchluessel()


  );
}

  @javax.persistence.Transient
  private transient LokalisierungProperties properties;

  public LokalisierungProperties getProperties(){
    if (properties == null) {
      properties = new LokalisierungProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public LokalisierungProperties getLokalisierungProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return LokalisierungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(LokalisierungConstants.MESSAGE_KEY_LOCALE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(LokalisierungConstants.MESSAGE_KEY_LOCALE_EINZAHL);

        locale =
     (de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(LokalisierungConstants.MESSAGE_KEY_MODUL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(LokalisierungConstants.MESSAGE_KEY_MODUL_EINZAHL);

        modul =
     (de.ivu.elect.business.lokalisierung.entity.LokalisierungModul) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(LokalisierungConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(LokalisierungConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL);

        schluessel =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(LokalisierungConstants.MESSAGE_KEY_WERT_GEAENDERT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(LokalisierungConstants.MESSAGE_KEY_WERT_GEAENDERT_EINZAHL);

        wertGeaendert =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(LokalisierungConstants.MESSAGE_KEY_WERT_PROPERTYDATEI_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(LokalisierungConstants.MESSAGE_KEY_WERT_PROPERTYDATEI_EINZAHL);

        wertPropertydatei =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertLocale) {
      result.put(LokalisierungConstants.MESSAGE_KEY_LOCALE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenLocale , locale));
    }
                            if (isSeitLadenVeraendertModul) {
      result.put(LokalisierungConstants.MESSAGE_KEY_MODUL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenModul , modul));
    }
                            if (isSeitLadenVeraendertSchluessel) {
      result.put(LokalisierungConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenSchluessel , schluessel));
    }
                            if (isSeitLadenVeraendertWertGeaendert) {
      result.put(LokalisierungConstants.MESSAGE_KEY_WERT_GEAENDERT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWertGeaendert , wertGeaendert));
    }
                            if (isSeitLadenVeraendertWertPropertydatei) {
      result.put(LokalisierungConstants.MESSAGE_KEY_WERT_PROPERTYDATEI_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWertPropertydatei , wertPropertydatei));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertLocale = false;
      wertNachLadenLocale = null;
                          isSeitLadenVeraendertModul = false;
      wertNachLadenModul = null;
                          isSeitLadenVeraendertSchluessel = false;
      wertNachLadenSchluessel = null;
                          isSeitLadenVeraendertWertGeaendert = false;
      wertNachLadenWertGeaendert = null;
                          isSeitLadenVeraendertWertPropertydatei = false;
      wertNachLadenWertPropertydatei = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "LOKALISIERUNG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Lokalisierung";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(locale, this, LokalisierungConstants.MESSAGE_KEY_LOCALE_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(modul, this, LokalisierungConstants.MESSAGE_KEY_MODUL_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(schluessel, this, LokalisierungConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(LokalisierungConstants.SCHLUESSEL_MAX_LENGTH , 1 ,  schluessel, this, LokalisierungConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(LokalisierungConstants.WERT_GEAENDERT_MAX_LENGTH ,  wertGeaendert, this, LokalisierungConstants.MESSAGE_KEY_WERT_GEAENDERT_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(LokalisierungConstants.WERT_PROPERTYDATEI_MAX_LENGTH ,  wertPropertydatei, this, LokalisierungConstants.MESSAGE_KEY_WERT_PROPERTYDATEI_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
